<template>
        <div class="app-layoutpanel Listpanel" v-loading="isLayoutLoadding" :style="{width: '100%', height: '100%',  overflow: 'auto'}">
        <template v-if="!isLayoutLoadding">
    <app-scroll-container name="container_scroll1" :layoutModelDetails="layoutModelDetails">
        <template #container_scroll_main1>
    <app-scroll-container name="container_scroll_main1" :layoutModelDetails="layoutModelDetails">
        <template #static_label1>
        <app-preset-text name="static_label1" :layoutModelDetails="layoutModelDetails"/>
        </template>
        <template #static_text1>
        <app-preset-text name="static_text1" :layoutModelDetails="layoutModelDetails"/>
        </template>
        <template #field_text_dynamic>
        <app-preset-text name="field_text_dynamic" :value="layoutData.field_text_dynamic" :layoutModelDetails="layoutModelDetails"/>
        </template>
        <template #field_textbox>
        <app-panel-field name="field_textbox" :layoutModelDetails="layoutModelDetails" :value="layoutData.field_textbox"> <input-box type="text" name="field_textbox" :itemValue="layoutData.field_textbox" :disabled="layoutModelDetails.field_textbox ? layoutModelDetails.field_textbox.disabled : false" @change="(value) => handleValueChange({ name: 'field_textbox', value})"> </input-box> </app-panel-field>
        </template>
        <template #button_link1>
        <app-preset-button name="button_link1" :layoutModelDetails="layoutModelDetails" @itemClick="handleButtonClick" />
        </template>
        <template #button_calluilogic1>
        <app-preset-button name="button_calluilogic1" :layoutModelDetails="layoutModelDetails" @itemClick="handleButtonClick" />
        </template>
    </app-scroll-container>
        </template>
    </app-scroll-container>
        </template>
    </div>

</template>
<script lang='tsx'>
import { Vue, Component, Prop, Provide, Emit, Watch, Model,Inject } from 'vue-property-decorator';
import { CreateElement } from 'vue';
import { Subject, Subscription } from 'rxjs';
import { ControlInterface } from '@/interface/control';
import { UIActionTool,Util,ViewTool } from '@/utils';
import NavDataService from '@/service/app/navdata-service';
import AppCenterService from "@service/app/app-center-service";
import IBIZBOOKEntityService from '@/service/ibizbook/ibizbook-service';
import ListpanelService from './listpanel-panel-service';
import IBIZBOOKUIService from '@/uiservice/ibizbook/ibizbook-ui-service';
import { PanelDetailModel,PanelRawitemModel,PanelTabPanelModel,PanelTabPageModel,PanelFieldModel,PanelContainerModel,PanelControlModel,PanelUserControlModel,PanelButtonModel } from '@/model/panel-detail';
import ListpanelModel from './listpanel-panel-model';
import CodeListService from "@/codelist/codelist-service";
import UIService from '@/uiservice/ui-service';


@Component({
    components: {
      
    }
})
export default class ListpanelBase extends Vue implements ControlInterface {

    /**
     * 名称
     *
     * @type {string}
     * @memberof ListpanelBase
     */
    @Prop() public name?: string;

    /**
     * 视图通讯对象
     *
     * @type {Subject<ViewState>}
     * @memberof ListpanelBase
     */
    @Prop() public viewState!: Subject<ViewState>;

    /**
     * 应用上下文
     *
     * @type {*}
     * @memberof ListpanelBase
     */
    @Prop() public context!: any;

    /**
     * 视图参数
     *
     * @type {*}
     * @memberof ListpanelBase
     */
    @Prop() public viewparams!: any;

    /**
     * 视图操作参数
     *
     * @type {*}
     * @memberof ListpanelBase
     */
    @Prop() public viewCtx!: any;

    /**
     * 视图状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof ListpanelBase
     */
    public viewStateEvent: Subscription | undefined;

    /**
     * 获取部件类型
     *
     * @returns {string}
     * @memberof ListpanelBase
     */
    public getControlType(): string {
        return 'PANEL'
    }



    /**
     * 计数器服务对象集合
     *
     * @type {Array<*>}
     * @memberof ListpanelBase
     */    
    public counterServiceArray:Array<any> = [];

    /**
     * 建构部件服务对象
     *
     * @type {ListpanelService}
     * @memberof ListpanelBase
     */
    public service: ListpanelService = new ListpanelService({ $store: this.$store });

    /**
     * 实体服务对象
     *
     * @type {IBIZBOOKService}
     * @memberof ListpanelBase
     */
    public appEntityService: IBIZBOOKEntityService = new IBIZBOOKEntityService({ $store: this.$store });
    


    /**
     * 转化数据
     *
     * @param {any} args
     * @memberof  ListpanelBase
     */
    public transformData(args: any) {
        let _this: any = this;
        if(_this.service && _this.service.handleRequestData instanceof Function && _this.service.handleRequestData('transform',_this.context,args)){
            return _this.service.handleRequestData('transform',_this.context,args)['data'];
        }
    }

    /**
     * 关闭视图
     *
     * @param {any} args
     * @memberof ListpanelBase
     */
    public closeView(args: any): void {
        let _this: any = this;
        _this.$emit('closeview', [args]);
    }

    /**
     *  计数器刷新
     *
     * @memberof ListpanelBase
     */
    public counterRefresh(){
        const _this:any =this;
        if(_this.counterServiceArray && _this.counterServiceArray.length >0){
            _this.counterServiceArray.forEach((item:any) =>{
                if(item.refreshData && item.refreshData instanceof Function){
                    item.refreshData();
                }
            })
        }
    }
    /**
     *  处理部件事件
     *
     * @memberof ListpanelBase
     */
    public async handleCtrlEvents(eventName: string, args: any = {}): Promise<boolean> {
        const actionData = {
            data: this.getData() || {},
            context: Util.deepCopy(this.context),
            viewparams: Util.deepCopy(this.viewparams),
            xData: this
        }
        let result: boolean = true;
        if (!result) {
            return false;
        }
        this.$emit(eventName, actionData);
        return true;
    }



    /**
     * 接口实现
     *
     * @returns {any[]}
     * @memberof ListpanelBase
     */
    getDatas(): any[] {
        if (!this.layoutData) {
            return [];
        }
        return [this.layoutData];
    }

    /**
     * 接口实现
     *
     * @returns {*}
     * @memberof ListpanelBase
     */
    getData() {
        return this.layoutData;
    }

    /**
     * 父级部件引用
     *
     * @type {*}
     * @memberof ListpanelBase
     */
    @Prop() public parentRef?: any;

    /**
     * 面板数据对象
     *
     * @type {*}
     * @memberof ListpanelBase
     */
    @Prop() public inputData?: any;

    /**
     * 操作栏模型数据
     *
     * @type {*}
     * @memberof ListpanelBase
     */
    @Prop() public actionModel?: any;

    /**
     * UI数据对象
     *
     * @type {*}
     * @memberof ListpanelBase
     */
    public data:any = {};

    /**
     * 数据模型对象
     *
     * @type {ListpanelModel}
     * @memberof ListpanelBase
     */
    public dataModel:ListpanelModel = new ListpanelModel();

    /**
     * 代码表服务对象
     *
     * @type {CodeListService}
     * @memberof ListpanelBase
     */
    public codeListService:CodeListService = new CodeListService();

    /**
     * 界面UI服务对象
     *
     * @type {IBIZBOOKUIService}
     * @memberof ListpanelBase
     */  
    public appUIService:IBIZBOOKUIService = new IBIZBOOKUIService();

    /**
     * 视图布局是否加载
     *
     * @public
     * @memberof List_itempanelBase
     */
    public isLayoutLoadding: boolean = false;

    /**
     * 视图布局数据
     *
     * @public
     * @memberof List_itempanelBase
     */
    public layoutData:any = {};

    /**
     * 视图布局面板模型对象
     *
     * @public
     * @memberof List_itempanelBase
     */
    public layoutModelDetails:any = {};

    /**
     * 视图布局顶级成员名称
     *
     * @public
     * @memberof List_itempanelBase
     */
    public rootLayoutDetailNames: string[] = [ 'container_scroll1' ];

    /**
     *  初始化布局
     *
     *  @public
     *  @memberof List_itempanelBase
     */
    public async initLayout() {
        if (this.rootLayoutDetailNames.length > 0) {
            for (let i = 0; i < this.rootLayoutDetailNames.length; i++) {
                const name = this.rootLayoutDetailNames[i];
                const rootItem = this.layoutItems[name];
                if (!rootItem) {
                    return;
                }
                await this.initLayoutItem(rootItem);
            }
        }
        return true;
    }

    /**
     *  初始化布局项
     *
     *  @public
     *  @memberof List_itempanelBase
     */
    public async initLayoutItem(layoutModelItem: any, index: number = 0) {
        const { name } = layoutModelItem;
        const layoutModelDetail = Util.getLayoutItemInstance(layoutModelItem);
        if (!index) {
            await layoutModelDetail.load(this.context, this.viewparams);
            this.$set(this.layoutModelDetails, name, layoutModelDetail);
            this.$set(this.layoutData, name, layoutModelDetail.getData());
        } else {
            layoutModelDetail.setIndex(index);
            await layoutModelDetail.load(this.context, this.viewparams);
            this.$set(this.layoutModelDetails, `${name}_${index}`, layoutModelDetail);
            this.$set(this.layoutData, `${name}_${index}`, layoutModelDetail.getData());
        }
        if (layoutModelDetail && layoutModelDetail.details) {
            if (layoutModelDetail.dataRegionType === 'MULTIDATA') {
                const multiData = layoutModelDetail.getData();
                if (multiData && multiData.length > 0) {
                    for (let i = 0; i < multiData.length; i++) {
                        for (let j = 0; j < layoutModelDetail.details.length; j++) {
                            const key = layoutModelDetail.details[j];
                            if (this.layoutItems[key]) {
                                await this.initLayoutItem(this.layoutItems[key], i);
                            }
                        }
                    }
                }
            } else {
                for (let i = 0; i < layoutModelDetail.details.length; i++) {
                    const key = layoutModelDetail.details[i];
                    if (this.layoutItems[key]) {
                        await this.initLayoutItem(this.layoutItems[key],index);
                    }
                }
            }
        }
    }

    /**
     * 视图布局面板项模型对象
     *
     * @public
     * @memberof List_itempanelBase
     */
    public layoutItems:any = {
        static_label1:{ name: 'static_label1', type: 'ITEMLAYOUT', caption: '标签', isShowCaption: true, sysCss: '', itemType: 'RAWITEM', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'', layoutPos:'CENTER', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:0, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container_scroll_main1', panel: this , viewType: 'DELISTVIEW', predefinedType: 'STATIC_LABEL', contentType: 'RAW', contentStyle: '', rawContent: '标签', htmlContent: '', renderMode: 'PARAGRAPH', wrapMode:'', vAlign:'', hAlign:'', },
        static_text1:{ name: 'static_text1', type: 'ITEMLAYOUT', caption: '文本', isShowCaption: true, sysCss: '', itemType: 'RAWITEM', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'', layoutPos:'CENTER', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:0, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container_scroll_main1', panel: this , viewType: 'DELISTVIEW', predefinedType: 'STATIC_TEXT', contentType: 'RAW', contentStyle: '', rawContent: '文本内容', htmlContent: '', renderMode: 'TEXT', wrapMode:'', vAlign:'', hAlign:'', },
        field_text_dynamic:{ name: 'field_text_dynamic', type: 'ITEMLAYOUT', caption: '文本(动态)', isShowCaption: false, sysCss: '', itemType: 'FIELD', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'', layoutPos:'CENTER', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:0, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container_scroll_main1', panel: this , required: false, fieldState: '0', predefinedType: 'FIELD_TEXT_DYNAMIC', renderMode: 'TEXT_DYNAMIC', dataItemName:'author', wrapMode:'', vAlign:'', hAlign:'', },
        field_textbox:{ name: 'field_textbox', type: 'ITEMLAYOUT', caption: '文本框', isShowCaption: false, sysCss: '', itemType: 'FIELD', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'', layoutPos:'CENTER', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:0, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container_scroll_main1', panel: this , required: false, fieldState: '0', predefinedType: 'FIELD_TEXTBOX', dataItemName:'booknumber', },
        button_link1:{ name: 'button_link1', type: 'ITEMLAYOUT', caption: '页面链接', isShowCaption: true, sysCss: '', itemType: 'BUTTON', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'', layoutPos:'CENTER', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:0, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container_scroll_main1', panel: this , xDataControlName: 'list', buttonStyle: 'DEFAULT', borderStyle: '', iconAlign: '', uiAction: { actiontarget: 'SINGLEDATA', noprivdisplaymode: '2', dataaccaction: '', visabled: true, disabled: false }, renderMode: 'LINK', },
        button_calluilogic1:{ name: 'button_calluilogic1', type: 'ITEMLAYOUT', caption: '按钮', isShowCaption: true, sysCss: '', itemType: 'BUTTON', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'', layoutPos:'CENTER', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:0, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container_scroll_main1', panel: this , xDataControlName: 'list', buttonStyle: 'DEFAULT', borderStyle: '', iconAlign: '', uiAction: { actiontarget: 'SINGLEKEY', noprivdisplaymode: '1', dataaccaction: 'OPEN_DOCUMENT', visabled: true, disabled: false }, renderMode: '', },
        container_scroll_main1:{ name: 'container_scroll_main1', type: 'ITEMLAYOUT', caption: '面板容器', titleBarCloseMode: 0, isShowCaption: true, sysCss: '', itemType: 'CONTAINER', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'BORDER', layoutPos:'CENTER', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:0, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container_scroll1', panel: this , details:['static_label1','static_text1','field_text_dynamic','field_textbox','button_link1','button_calluilogic1'] , dataRegionType: 'INHERIT' },
        container_scroll1:{ name: 'container_scroll1', type: 'ITEMLAYOUT', caption: '滚动条容器', titleBarCloseMode: 0, isShowCaption: false, sysCss: '', itemType: 'CONTAINER', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'BORDER', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:0, flexParams:{align:'',dir:'',vAlign:''}, panel: this , details:['container_scroll_main1'] , dataRegionType: 'INHERIT' }
    };

    /**
     * 监听数据对象
     *
     * @memberof ListpanelBase
     */
    @Watch('inputData', { deep: true, immediate: true } )
    public onInputDataChange(newVal: any, oldVal: any){
        if(newVal){
            this.computedUIData(newVal);
        }
    }

    /**
     * 生命周期
     *
     * @memberof ListpanelBase
     */
    public mounted () {
        this.afterMounted();
    }

    /**
     * 执行mounted后的逻辑
     *
     * @memberof ListpanelBase
     */
    public afterMounted () {
        const _this: any = this;
        _this.initLayout().then((result: any) => {
            _this.isLayoutLoadding = false;
        });
    }

    /**
     * 计算UI展示数据
     * 
     * @param codelistArray 代码表模型数组
     * @memberof ListpanelBase
     */
    public computedUIData(newVal:any){
        if((this.dataModel.getDataItems instanceof Function) && this.dataModel.getDataItems().length >0){
            this.dataModel.getDataItems().forEach((item:any) =>{
                this.data[item.prop] = newVal[item.prop];
            })
        }
    }

    /**
     * 打开编辑数据视图
     *
     * @type {any}
     * @memberof ListpanelBase
     */
    public opendata(args: any[],fullargs?:any[],params?: any, $event?: any, xData?: any){
        if (this.parentRef.opendata && this.parentRef.opendata instanceof Function) {
            this.parentRef.opendata(args,fullargs,params, $event, xData);
        }
    }

    /**
     * 打开新建数据视图
     *
     * @type {any}
     * @memberof ListpanelBase
     */
    public newdata(args: any[],fullargs?:any[], params?: any, $event?: any, xData?: any) {
        if (this.parentRef.newdata && this.parentRef.newdata instanceof Function) {
            this.parentRef.newdata(args,fullargs,params, $event, xData);
        }
    }
    
    /**
     * 删除
     *
     * @param {any[]} datas
     * @returns {Promise<any>}
     * @memberof ListpanelBase
     */
    public async remove(datas: any[]): Promise<any> {
        if (this.parentRef.remove && this.parentRef.remove instanceof Function) {
            return this.parentRef.remove(datas);
        }
    }

    /**
     * 刷新
     *
     * @param {*} [args={}]
     * @memberof ListpanelBase
     */
    public refresh(args: any = {}) {
        if (this.parentRef.refresh && this.parentRef.refresh instanceof Function) {
            this.parentRef.refresh(args);
        }
    }

    /**
     * 处理值改变
     *
     * @public
     * @params args 改变数据
     * @params index 多数据容器下标
     * @memberof List_itempanelBase
     */
    public handleValueChange(args: { name: string, value: any }, index?: number) {
        if (!args || !args.name || Object.is(args.name, '') || !this.layoutData.hasOwnProperty(args.name)) {
            return;
        }
        const { name, value } = args;
        this.layoutData[name] = value;
        this.layoutModelDetails[name].setData(value);
        this.panelLogic(name, index);
        this.computeButtonAuthState();
        this.panelEditItemChange(name, value);
    }

    /**
     * 计算按钮权限状态
     *
     * @public
     * @memberof List_itempanelBase
     */
    public computeButtonAuthState() {
        Object.values(this.layoutModelDetails).forEach((layoutModel: any) => {
            if (layoutModel.itemType == 'BUTTON') {
                layoutModel.computeActionAuthState();
            }
        })
    }

    /**
     * 面板编辑项值变化后续操作
     *
     * @public
     * @param property 编辑项名
     * @param value 编辑项值
     * @returns {void}
     * @memberof ListpanelBase
     */
    public panelEditItemChange(property: string, value: any){
        // 面板数据变化事件
        if((this.dataModel.getDataItems instanceof Function) && this.dataModel.getDataItems().length >0){
            let modelitem =this.dataModel.getDataItems().find((item:any) =>{
                return item.name === property;
            }) 
            if(modelitem){
                this.$emit('panelDataChange',{[modelitem.prop]: value});
            }
        }
    }

    /**
     * 面板逻辑
     *
     * @public
     * @params name 改变项名称
     * @params index 多数据容器下标
     * @memberof ListpanelBase
     */
    public panelLogic(name: string, index?: number): void {
        if (name && (index || index === 0)) {
            name = name.replace(`_${index}`,"");
        }
    }

    /**
     * 处理按钮点击
     *
     * @public
     * @memberof List_itempanelBase
     */
    public handleButtonClick(name: string, $event?: any) {
        let datas: any[] = [];
        const data: any = this.layoutModelDetails[name].getData();
        if (data) {
            if (data instanceof Array) {
                datas = [...data];
            } else {
                datas = [data];
            }
        }
        const xData: any = this.layoutModelDetails[name].getDataArea();
        const paramJO: any = {};
        const contextJO: any = {};
        const _this: any = this;
        if (Object.is(name, 'button_link1')) {
            window.uiServiceRegister.getService('ibizbook').then((UIService: any) => {
                if (UIService && UIService[`IBIZBOOK_panel_Listpanel_button_link1_click`] && UIService[`IBIZBOOK_panel_Listpanel_button_link1_click`] instanceof Function) {
                    UIService[`IBIZBOOK_panel_Listpanel_button_link1_click`](datas, contextJO, paramJO,  $event, xData, this, undefined);
                }
            })
        }
        if (Object.is(name, 'button_calluilogic1')) {
            window.uiServiceRegister.getService('ibizbook').then((UIService: any) => {
                if (UIService && UIService[`IBIZBOOK_openDocument`] && UIService[`IBIZBOOK_openDocument`] instanceof Function) {
                    UIService[`IBIZBOOK_openDocument`](datas, contextJO, paramJO,  $event, xData, this, undefined);
                }
            })
        }
    }


}
</script>

<style lang='less'>
@import './listpanel-panel.less';
</style>

